package me.brianlong.git;

import org.eclipse.jgit.api.CloneCommand;
import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.api.errors.InvalidRemoteException;
import org.eclipse.jgit.api.errors.TransportException;
import org.eclipse.jgit.lib.Repository;

public class CachedGit extends Git {
	
	public CachedGit(Git git) {
		super(git.getRepository());
	}
	
	public CachedGit(CloneCommand clone) throws TransportException, InvalidRemoteException, GitAPIException {
		super(clone.call().getRepository());
	}
	
	public CachedGit(Repository repo) {
		super(repo);
	}
	
	@Override
	public void close() {
		LocalRepositoryCache.getInstance().release(this);
	}

}
